<?php
// $Id: submission.inc,v 1.1 2006/09/06 19:37:02 nedjo Exp $

/**
 * Implementation of hook_load().
 */
function formbuilderpage_submission_load($node) {
  $formbuilderpage_submission = db_fetch_object(db_query('SELECT * FROM {formbuilderpage_submission} WHERE vid = %d', $node->vid));
  $formbuilderpage_submission->form_values = unserialize($formbuilderpage_submission->form_values);
  return $formbuilderpage_submission;
}

/**
 * Implementation of hook_view().
 *
 * Add the appropriate form to the node body.
 */
function formbuilderpage_submission_view(&$node, $teaser = FALSE, $page = FALSE) {

  $node = node_prepare($node, $teaser);

  $node->body .= theme('formbuilderpage_submission_form_values', $node);
}

/**
 * Implementation of hook_insert().
 */
function formbuilderpage_submission_insert($node) {
  db_query("INSERT INTO {formbuilderpage_submission} (nid, vid, form_node, form_values) VALUES (%d, %d, '%s', '%s')", $node->nid, $node->vid, $node->form_node, $node->form_values);
}

/**
 * Implementation of hook_update().
 */
function formbuilderpage_submission_update($node) {
  if ($node->revision) {
    formbuilderpage_submission_insert($node);
  }
  else {
    db_query("UPDATE {formbuilderpage_submission} SET form_node = '%s', form_values = '%s' WHERE vid = %d", $node->form_node, $node->form_values, $node->vid);
  }
}

/**
 * Implementation of hook_delete().
 */
function formbuilderpage_submission_delete(&$node) {
  db_query('DELETE FROM {formbuilderpage_submission} WHERE nid = %d', $node->nid);
}

/**
 * Theme the values of a node submission.
 */
function theme_formbuilderpage_submission_form_values($node) {
  $header = array(t('Field'), t('Value'));
  $rows = array();
  if ($node->form_values && is_array($node->form_values)) {
    foreach ($node->form_values as $key => $value) {
      $rows[] = array(check_plain($key), check_plain($value));
    }
  }
  return theme('table', $header, $rows);
}